import 'package:flutter/material.dart';
import 'package:iotpaycreditcard/config/MyConfig.dart';
import 'package:iotpaycreditcard/providers/dataProvider.dart';

// ignore: must_be_immutable
class TextFieldWidget extends StatelessWidget {
  DataProvider dataProvider;
  final double contextWidth;
  final Map<String, dynamic> item;

  TextFieldWidget(
      {required this.dataProvider,
      required this.contextWidth,
      required this.item});
  Widget build(BuildContext context) {
    return Container(
      width: dataProvider.getWidth(item, contextWidth),
      child: TextField(
        autofocus: true,
        keyboardType: item['inputType'],
        decoration: InputDecoration(
          hintText: dataProvider.isTripleLine
              ? item['placeholder'].toString()
              : item['placeholdershort'],
          hintStyle: TextStyle(
              color: item['name'] == MyConfig.CARDNUMBER.name
                  ? Colors.white
                  : Colors.black,
              fontSize: item['fontSize'],
              fontStyle: item['fontStyle'],
              fontWeight: item['fontWeight']),
          suffixIcon: item['sufficIcon'],

          /*enabledBorder: UnderlineInputBorder(
            borderRadius: BorderRadius.circular(10),
            borderSide: BorderSide(color: Colors.white),
          ),*/
        ),
        onTap: () =>
            {dataProvider.onTab(item['name'].toString(), contextWidth)},
        onChanged: (String value) =>
            {dataProvider.onChange(item['name'].toString(), value)},
        controller: item['txtEditingController'],
        style: TextStyle(
            color: item['name'] == MyConfig.CARDNUMBER.name
                ? Colors.white
                : Colors.black,
            fontSize: item['fontSize'],
            fontStyle: item['fontStyle'],
            fontWeight: item['fontWeight']),

        //focusNode: focusNode,
      ),
    );
  }
}
